#ifndef __HANDY_STRINGBUFFER_H__
#define __HANDY_STRINGBUFFER_H__

#include <string>
class StringBuffer {
    std::string str;
    unsigned len;
    unsigned idx;

public:
    StringBuffer(const char *s = "");
    StringBuffer(const std::string &str);
    ~StringBuffer();

    // ۸ ڿ ʱȭմϴ.
    void init(const char *str);
    void init(const std::string &str);

    // ۷κ ڸ ϳ нϴ. Ͱ ̵մϴ.
    char getc();
    //  Ͱ Ű ڸ ɴϴ. ʹ ̵ ʽϴ.
    char peekc() const;
    // ۿ о  ǵϴ. ǵ   false ȯմϴ.
    bool ungetc();

    //    Ǵ ڿ ߰մϴ.
    void add(char c);
    void add(const char *s);
    void add(const std::string &str);

    // ۰ ִٸ true,     ִٸ false ȯմϴ.
    bool is_empty() const;
};

#endif